*( NEWDOC.CMD--Add WordPerfect document to WPDOCS table.)
CLS; SET MESSAGES OFF; SET ERROR MESSAGES OFF
DEBUG SET MESSAGES ON; DEBUG SET ERROR MESSAGES ON
CLEAR VAR v1, v2, v3, v4
SET VAR v1 TEXT, v2 TEXT, v3 TEXT, v4 TEXT
FILLIN v1 USING 'Enter name of WordPerfect main document file: '
IF v1 IS NULL THEN
  WRITE 'ERROR - You must enter a main document file name.'
  GOTO endoc
ENDIF
WRITE 'Here are the current document descriptions:'
SET HEADINGS OFF
SELECT wpdesc FROM wpdocs
SET HEADINGS ON
DIALOG 'Enter unique description for the new main document: ' +
  v2 vend 2
IF vend IN ('[Esc]','HELP') OR vend IS NULL THEN
  WRITE 'ERROR - You must enter a description.'
  GOTO endoc
ENDIF
FILLIN v3 USING 'Enter name of the table or view with merge data: '
IF v3 IS NULL THEN
  WRITE 'ERROR - You must enter a table or view name.'
  GOTO endoc 
ENDIF
WRITE 'Choose merge columns from ' .v3 'in the order you use them + in the merge document. Press [Esc] when finished.'
CHOOSE v4 FROM #COLUMNS IN &v3 +
  CLEAR FOOTING CHKBOX 10
IF v4 IN ('[Esc]','HELP') OR v4 IS NULL THEN
  WRITE 'ERROR - You must choose at least one column.'
  GOTO endoc
ENDIF
CLS
WRITE 'You chose these columns in this order:'
WRITE '  ' .v4
WRITE 'from this table or view:' .v3 'to go into this document:' .v1
WRITE 'described as:' .v2 
DIALOG 'Is everything correct?' vcorrect vend NO  AT 11; CLS
IF vcorrect = 'No' THEN
  WRITE 'Program aborted, new document not added.'
  GOTO endoc
ELSE
  INSERT INTO wpdocs (wpfile, wpdesc, wptbl, wpcols) +
    VALUES (.v1,.v2,.v3,.v4)
ENDIF
LABEL endoc
*( Clear variables if NOT debugging.)
SET VAR vdebug = (CVAL('DEBUG'))
IF vdebug = 'OFF' THEN
  CLEAR VAR v1, v2, v3, v4, vend, vlen, vcorrect, vdebug
ENDIF
RETURN

